function bench_mtimes(LN,m,n,p,nbruns)
  versions={'Cpt','Mat','Vec'};

  setfun=@(varargin) fc_linalg3D.benchs.set_mtimes(varargin{:});

  Lfun={@(varargin) fc_linalg3D.mtimes_Cpt(varargin{:}), ...
        @(varargin) fc_linalg3D.mtimes_Mat(varargin{:}), ...
        @(varargin) fc_linalg3D.mtimes_Vec(varargin{:})};

  dl=[m,n];dr=[n,p]; 
  Error=@(o1,o2) max(max(max(abs(o1-o2))))+(size(o2,2)~=dl(1)) +(size(o2,3)~=dr(2)) ;
  fc_bench.bench(Lfun,setfun,LN,'dl',dl,'dr',dr,'nbruns',nbruns,'error',Error)
  dl=[1,n];dr=[n,p]; 
  Error=@(o1,o2) max(max(max(abs(o1-o2))))+(size(o2,2)~=dl(1)) +(size(o2,3)~=dr(2)) ;
  fc_bench.bench(Lfun,setfun,LN,'dl',dl,'dr',dr,'nbruns',nbruns,'error',Error)
  dl=[1,n];dr=[n,1];  
  Error=@(o1,o2) max(max(max(abs(o1-o2)))) +(length(size(o2))~=2);
  fc_bench.bench(Lfun,setfun,LN,'dl',dl,'dr',dr,'nbruns',nbruns,'error',Error)
  dl=[m,n];dr=[n,1];
  Error=@(o1,o2) max(max(max(abs(o1-o2))));
  fc_bench.bench(Lfun,setfun,LN,'dl',dl,'dr',dr,'nbruns',nbruns,'error',Error)

  type='array2d';
  dl=[m,n];dr=[n,p]; % N-by-2-by-4
  Error=@(o1,o2) max(max(max(abs(o1-o2))))+(size(o2,2)~=dl(1)) +(size(o2,3)~=dr(2)) ;
  fc_bench.bench(Lfun,setfun,LN,'dl',dl,'dr',dr,'nbruns',nbruns,'error',Error,'rtype',type)
  dl=[1,n];dr=[n,p];
  Error=@(o1,o2) max(max(max(abs(o1-o2))))+(size(o2,2)~=dl(1)) +(size(o2,3)~=dr(2)) ;
  fc_bench.bench(Lfun,setfun,LN,'dl',dl,'dr',dr,'nbruns',nbruns,'error',Error,'rtype',type)
  dl=[1,n];dr=[n,1];
  Error=@(o1,o2) max(max(max(abs(o1-o2))))+(size(o2,2)~=dl(1)) +(size(o2,3)~=dr(2)) ;
  fc_bench.bench(Lfun,setfun,LN,'dl',dl,'dr',dr,'nbruns',nbruns,'error',Error,'rtype',type)
  dl=[m,n];dr=[n,1];
  Error=@(o1,o2) max(max(max(abs(o1-o2))))+(size(o2,2)~=dl(1)) +(size(o2,3)~=dr(2)) ;
  fc_bench.bench(Lfun,setfun,LN,'dl',dl,'dr',dr,'nbruns',nbruns,'error',Error,'rtype',type)

  dl=[m,n];dr=[n,p];
  Error=@(o1,o2) max(max(max(abs(o1-o2))))+(size(o2,2)~=dl(1)) +(size(o2,3)~=dr(2)) ;
  fc_bench.bench(Lfun,setfun,LN,'dl',dl,'dr',dr,'nbruns',nbruns,'error',Error,'ltype',type)
  dl=[1,n];dr=[n,p];
  Error=@(o1,o2) max(max(max(abs(o1-o2))))+(size(o2,2)~=dl(1)) +(size(o2,3)~=dr(2)) ;
  fc_bench.bench(Lfun,setfun,LN,'dl',dl,'dr',dr,'nbruns',nbruns,'error',Error,'ltype',type)

  %  -> Don't work as N-by-3-by-1 <=> N-by-3 under Matlab/Octave!
  %  dl=[1,3];dr=[3,1];
  %  Error=@(o1,o2) max(max(max(abs(o1-o2))))+(size(o2,2)~=dl(1)) +(size(o2,3)~=dr(2)) ;
  %  fc_bench.bench(Lfun,setfun,LN,'dl',dl,'dr',dr,'nbruns',nbruns,'error',Error,'ltype',type)
  %  dl=[2,3];dr=[3,1];
  %  Error=@(o1,o2) max(max(max(abs(o1-o2))))+(size(o2,2)~=dl(1)) +(size(o2,3)~=dr(2)) ;
  %  fc_bench.bench(Lfun,setfun,LN,'dl',dl,'dr',dr,'nbruns',nbruns,'error',Error,'ltype',type)
end
