function B=ctranspose(A)
% A : N-by-n-by-d, 
% B : N-by-n-by-m such that B(k,:,:)=A(k,:,:)^* is the conjugate transpose
% N >> n,d,m
  B=fc_linalg3D.transpose(A);
  if ~isreal(A)
    B=conj(B);
  end
end
